- Qt 5.15
- Qt Virtual Keyboard
- QML Types
- TraceCanvas QML Type
- Qt Virtual Keyboard | Commercial or GPLv3

# TraceCanvas QML Type

A specialized Canvas type for rendering Trace objects. More...

Import Statement: | import QtQuick.VirtualKeyboard.Styles 2.15
Since: | QtQuick.VirtualKeyboard 2.0

- List of all members, including inherited members

## Properties

- autoDestroy : bool
- autoDestroyDelay : int
- renderFunction : var
- trace : var

## Methods

- renderSmoothedLine()

## Detailed Description

This type provides capabilities for rendering Trace objects on the screen.

To make the Trace rendering available in the keyboard, this type must be declared as the KeyboardStyle.traceCanvasDelegate component.

     traceCanvasDelegate: TraceCanvas {
     }

Custom drawing attributes can be initialized in the Canvas.available signal. For example:

     onAvailableChanged: {
         if (!available)
             return;
         var ctx = getContext("2d")
         ctx.lineWidth = 8 * scaleHint
         ctx.lineCap = "round"
         ctx.strokeStyle = Qt.rgba(0xFF, 0xFF, 0xFF)
         ctx.fillStyle = ctx.strokeStyle
     }

The type offers built-in options for Trace rendering. Currently the following rendering options are available:

- `renderSmoothedLine` Renders smoothed line with round corners (the default)

The rendering function can be changed with the renderFunction property.

     renderFunction: renderSmoothedLine

Custom rendering function is also supported. Consider the following example:

     renderFunction: renderCustomLine

     function renderCustomLine() {
         getContext("2d")
         var points = trace.points()

         ...
     }

## Property Documentation

autoDestroy : bool

Enables auto destruction mode.

If enabled, this item will be destroyed when the `trace` object is destroyed.

The default value is false.

autoDestroyDelay : int

Specifies the approximate delay in milliseconds, counted from the beginning of the auto destruction, before the object is to be destroyed.

This delay makes it possible, for example, to animate the item before destruction.

The default value is 0.

renderFunction : var

This property defines the rendering function.

The default value is `renderSmoothedLine`

trace : var

Provides access to Trace object.

## Method Documentation

renderSmoothedLine()

Renders smoothed line with round corners.

This function is incremental and renders only the new part added to the Trace.

This function does not alter any of the canvas attributes (i.e. they can be set elsewhere.)